## grantlee 0.1.1

=== CMakeLists.txt ===
project(Grantlee)

cmake_minimum_required(VERSION 2.6)

find_package(Qt4 4.5.0 REQUIRED)

option( BUILD_CORE "Build the Grantlee core library" TRUE )
option( BUILD_GUI "Build the Grantlee gui library" TRUE )
option( BUILD_MAIN_PLUGINS "Build the Grantlee plugins" TRUE )
option( BUILD_SCRIPT_PLUGIN "Build the Grantlee scriptable tags plugin" TRUE )
option( BUILD_TESTS "Build the Grantlee tests" TRUE )

if (BUILD_TESTS)
  enable_testing()
endif()

set(CMAKE_MODULE_PATH ${Grantlee_SOURCE_DIR}/cmake/modules)

if (CMAKE_COMPILER_IS_GNUCXX)
  set (CMAKE_C_FLAGS   "${CMAKE_C_FLAGS} -Wno-long-long -std=iso9899:1990 -Wundef -Wcast-align -Werror-implicit-function-declaration -Wchar-subscripts -Wall -W -Wpointer-arith -Wwrite-strings -Wformat-security -Wmissing-format-attribute -fno-common")
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wnon-virtual-dtor -Wno-long-long -ansi -Wundef -Wcast-align -Wchar-subscripts -Wall -W -Wpointer-arith -Wformat-security -fno-check-new -fno-common -pedantic-errors")
  if (NOT MINGW)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
  else ()
    # http://mail.kde.org/pipermail/kde-windows/2007-December/001692.html
    # http://lists.trolltech.com/pipermail/qt-interest/2009-July/009829.html
    # qt is always compiled with QT_NO_DEBUG under mingw,
    # so we need to compile stuff linked against it
    # the same or otherwise QPluginLoader rejects plugins
    add_definitions(-DQT_NO_DEBUG)
  endif ()
endif()

set(Grantlee_VERSION_MAJOR 0)
set(Grantlee_VERSION_MINOR 1)
set(Grantlee_VERSION_PATCH 1)
set(Grantlee_MIN_PLUGIN_VERSION 1)

set(Grantlee_MAJOR_MINOR_VERSION_STRING "${Grantlee_VERSION_MAJOR}.${Grantlee_VERSION_MINOR}" )
set(Grantlee_VERSION_STRING "${Grantlee_VERSION_MAJOR}.${Grantlee_VERSION_MINOR}.${Grantlee_VERSION_PATCH}" )

set (LIB_SUFFIX "" CACHE STRING "Define suffix of library directory name (eg. '64')")

set( LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX} )
set( PLUGIN_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}/grantlee/${Grantlee_MAJOR_MINOR_VERSION_STRING} )
set( BIN_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/bin )
set( INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/include )
set( DATA_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/share/apps )
set( CMAKE_INSTALL_NAME_DIR ${LIB_INSTALL_DIR})

set(Grantlee_USE_FILE "${Grantlee_SOURCE_DIR}/cmake/modules/GrantleeUse.cmake")

if (BUILD_CORE)
  set(Grantlee_CORE_LIBRARY "grantlee_core")
  set(Grantlee_CORE_LIBRARIES ${Grantlee_CORE_LIBRARY} ${QT_QTCORE_LIBRARIES} )
  add_subdirectory(corelib)
endif()

if (BUILD_GUI)
  set(Grantlee_GUI_LIBRARY "grantlee_gui")
  set(Grantlee_GUI_LIBRARIES ${Grantlee_GUI_LIBRARY} ${QT_QTGUI_LIBRARIES} )
  add_subdirectory(gui)
endif()

if (BUILD_MAIN_PLUGINS)
  add_subdirectory(loadertags)
  add_subdirectory(defaulttags)

  add_subdirectory(defaultfilters)
endif()

if (BUILD_SCRIPT_PLUGIN)
#  add_subdirectory(scriptabletags)
endif()

if (BUILD_TESTS)
  add_subdirectory(tests)
endif()

configure_file(
  "${CMAKE_MODULE_PATH}/GrantleeConfig.cmake.in"
  "${Grantlee_BINARY_DIR}/GrantleeConfig.cmake"
  IMMEDIATE @ONLY
)

configure_file(
  "${CMAKE_MODULE_PATH}/GrantleeConfigVersion.cmake.in"
  "${Grantlee_BINARY_DIR}/GrantleeConfigVersion.cmake"
  IMMEDIATE @ONLY
)

install(FILES
  "${Grantlee_BINARY_DIR}/GrantleeConfig.cmake"
  "${Grantlee_BINARY_DIR}/GrantleeConfigVersion.cmake"
  DESTINATION "${LIB_INSTALL_DIR}/grantlee")

install(FILES
  "${CMAKE_MODULE_PATH}/GrantleeUse.cmake"
  DESTINATION "${PLUGIN_INSTALL_DIR}"
)

# Add support for an uninstall target
configure_file(
  "${CMAKE_MODULE_PATH}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

add_custom_target(uninstall
  "${CMAKE_COMMAND}" -P
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

find_package(Doxygen)
if (DOXYGEN_FOUND AND DOXYGEN_DOT_FOUND)
  message (STATUS "Doxygen and dot found. make docs target is available")
  # Add support for a docs target

  set(TAGFILES "${CMAKE_SOURCE_DIR}/scripts/qttags.tag=http://qt.nokia.com/doc/${QT_VERSION_MAJOR}.${QT_VERSION_MINOR}")
  set(DOCS_OUTPUT_DIRECTORY "@CMAKE_BINARY_DIR@/apidocs")
  configure_file(
    "${CMAKE_MODULE_PATH}/Doxyfile.in"
    "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile"
    IMMEDIATE @ONLY)

  # Add support for a Qt assistant docs target
  # qttags.tag is too big to distribute with Grantlee. Get it
  # from http://api.kde.org/kdereview-api/kdereview.tar.gz for example.
  if(EXISTS ${CMAKE_SOURCE_DIR}/scripts/qttags.tag)
    set(DOCS_OUTPUT_DIRECTORY "@CMAKE_BINARY_DIR@/qtdocs")
    set(TAGFILES "${CMAKE_SOURCE_DIR}/scripts/qttags.tag=qthelp://com.trolltech.qt/qdoc/")
    set(GENERATE_QHP "yes")

    configure_file(
      "${CMAKE_MODULE_PATH}/Doxyfile.in"
      "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile.qt"
      IMMEDIATE @ONLY)
  endif()

  set( DOCS_ARGS ${DOXYGEN_EXECUTABLE} "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile" )
  if(EXISTS "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile.qt")
    set(DOCS_ARGS ${DOCS_ARGS} COMMAND ${DOXYGEN_EXECUTABLE} "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile.qt" )
  endif()

  add_custom_target(docs
    ${DOCS_ARGS}
  )
endif()

=== corelib/CMakeLists.txt ===
project(grantlee_core)

include_directories(
  ${QT_INCLUDES}
  ${PROJECT_BINARY_DIR}
  ${PROJECT_SOURCE_DIR}
  ${PROJECT_SOURCE_DIR}/../scriptabletags
)

include(${QT_USE_FILE})

configure_file(grantlee_version.h.cmake ${PROJECT_BINARY_DIR}/grantlee_version.h)

set (grantlee_core_SRCS
  context.cpp
  engine.cpp
  filterexpression.cpp
  lexer.cpp
  node.cpp
  nodebuiltins.cpp
  outputstream.cpp
  parser.cpp
  safestring.cpp
  template.cpp
  templateloader.cpp
  util.cpp
  variable.cpp
)

set(scriptabletags_FILES
  scriptablecontext.cpp
  scriptablefilterexpression.cpp
  scriptablenode.cpp
  scriptableparser.cpp
  scriptablesafestring.cpp
  scriptabletags.cpp
  scriptabletemplate.cpp
  scriptablevariable.cpp
  scriptablefilter.cpp
)

foreach(file ${scriptabletags_FILES})
  set(scriptabletags_SRCS ${scriptabletags_SRCS} ${CMAKE_SOURCE_DIR}/scriptabletags/${file})
endforeach()

set(Grantlee_CORE_LIB_SOVERSION 0)

set(moc_SRCS ${grantlee_core_SRCS} ${scriptabletags_SRCS})

qt4_automoc(${moc_SRCS})

add_library(grantlee_core SHARED
  ${grantlee_core_SRCS}
  ${scriptabletags_SRCS}
)

target_link_libraries(grantlee_core
  ${QT_QTCORE_LIBRARY}
  ${QT_QTSCRIPT_LIBRARY}
)

set_target_properties(grantlee_core PROPERTIES
  VERSION    ${Grantlee_VERSION_MAJOR}.${Grantlee_VERSION_MINOR}.${Grantlee_VERSION_PATCH}
  SOVERSION  ${Grantlee_CORE_LIB_SOVERSION}
  DEFINE_SYMBOL GRANTLEE_CORE_LIB_MAKEDLL
)

install(TARGETS grantlee_core
         RUNTIME DESTINATION ${BIN_INSTALL_DIR}
         LIBRARY DESTINATION ${LIB_INSTALL_DIR}
         ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
         COMPONENT Devel
)

install(FILES
  context.h
  engine.h
  exception.h
  filter.h
  filterexpression.h
  grantlee_core_export.h
  ${PROJECT_BINARY_DIR}/grantlee_version.h
  node.h
  outputstream.h
  parser.h
  safestring.h
  taglibraryinterface.h
  template.h
  templateloader.h
  token.h
  util.h
  variable.h
  DESTINATION ${INCLUDE_INSTALL_DIR}/grantlee COMPONENT Devel
)

install(FILES
  grantlee_core.h
  DESTINATION ${INCLUDE_INSTALL_DIR} COMPONENT Devel
)

=== tests/CMakeLists.txt ===
project(grantleetests)

include(${QT_USE_FILE})

include_directories( ${QT_INCLUDES}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${PROJECT_SOURCE_DIR}/../corelib
  ${PROJECT_SOURCE_DIR}/../gui
)

set( EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR} )

set( GRANTLEE_PLUGIN_PATH "${CMAKE_BINARY_DIR}/" )

configure_file(grantlee_paths.h.cmake ${PROJECT_BINARY_DIR}/grantlee_paths.h)

set (_rcc_file "scriptedtags.qrc")
qt4_add_resources(_scripted_rcc_src ${_rcc_file} OPTIONS -root "/plugins/grantlee/${Grantlee_MAJOR_MINOR_VERSION_STRING}" )

macro(GRANTLEE_UNIT_TESTS)
  foreach(_testname ${ARGN})
    set(_testSrcs ${_testname}.cpp)
    set(moc_output_file "${CMAKE_CURRENT_BINARY_DIR}/${_testname}.moc")
    qt4_generate_moc(${_testname}.cpp ${moc_output_file})
    add_executable(${_testname}_exec ${_testSrcs} ${moc_output_file} ${_scripted_rcc_src} ${CMAKE_SOURCE_DIR}/corelib/lexer.cpp)
    add_test(${_testname} ${_testname}_exec )
    target_link_libraries(${_testname}_exec ${QT_QTTEST_LIBRARY} ${QT_QTGUI_LIBRARY} ${Grantlee_CORE_LIBRARIES} ${Grantlee_GUI_LIBRARY} )
  endforeach(_testname)
endmacro(GRANTLEE_UNIT_TESTS)

grantlee_unit_tests(
  testsafestring
  testbuiltins
  testloadertags
  testdefaulttags
  testscriptabletags
  testfilters
  htmlbuildertest
  plainmarkupbuildertest
  benchmarks
)

add_subdirectory(pluginpointertest)

=== debian/changelog ===
grantlee (0.1.1-0ubuntu2~lucid1) lucid-backports; urgency=low

  * Automated backport upload; no source changes.

 -- Harald Sitter <apachelogger@ubuntu.com>  Tue, 22 Jun 2010 17:27:36 +0100

grantlee (0.1.1-0ubuntu2) maverick; urgency=low

  * Add BZR branch information
  * Update debian/copyright a bit and mention my copyright on debian/*

 -- Harald Sitter <apachelogger@ubuntu.com>  Tue, 15 Jun 2010 15:46:55 +0200

grantlee (0.1.1-0ubuntu1) maverick; urgency=low

  * Initial Release

 -- Harald Sitter <apachelogger@ubuntu.com>  Fri, 11 Jun 2010 23:41:45 +0200

=== debian/control ===
Source: grantlee
Section: libs
Priority: extra
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Harald Sitter <apachelogger@ubuntu.com>
Build-Depends: debhelper (>= 7.3.16), cmake, libqt4-dev
Standards-Version: 3.8.4
Vcs-Browser: http://bazaar.launchpad.net/~kubuntu-members/grantlee/ubuntu
Vcs-Bzr: https://code.launchpad.net/~kubuntu-members/grantlee/ubuntu

Package: libgrantlee0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: plugin-based string template library for Qt
 The goals of the software is to make it easier for application developers to
 separate the structure of documents from the data they contain, opening the
 door for theming.
 .
 This package contains the Grantlee library itself.

Package: libgrantlee-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libgrantlee0 (= ${binary:Version})
Description: plugin-based string template library for Qt - development headers
 The goals of the software is to make it easier for application developers to
 separate the structure of documents from the data they contain, opening the
 door for theming.
 .
 This package contains the development headers of Grantlee.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_TESTS=FALSE

DEB_DH_BUILDDEB_ARGS += -- -Zlzma

## grantlee 0.1.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -33,7 +33,7 @@
 
 set(Grantlee_VERSION_MAJOR 0)
 set(Grantlee_VERSION_MINOR 1)
-set(Grantlee_VERSION_PATCH 1)
+set(Grantlee_VERSION_PATCH 4)
 set(Grantlee_MIN_PLUGIN_VERSION 1)
 
 set(Grantlee_MAJOR_MINOR_VERSION_STRING "${Grantlee_VERSION_MAJOR}.${Grantlee_VERSION_MINOR}" )

=== corelib/CMakeLists.txt ===
--- 
+++ 
@@ -10,6 +10,7 @@
 include(${QT_USE_FILE})
 
 configure_file(grantlee_version.h.cmake ${PROJECT_BINARY_DIR}/grantlee_version.h)
+configure_file(grantlee_config_p.h.cmake  ${PROJECT_BINARY_DIR}/grantlee_config_p.h)
 
 set (grantlee_core_SRCS
   context.cpp

=== defaultfilters/CMakeLists.txt ===
project(grantlee_defaultfilters)

include_directories(
  ${QT_INCLUDES}
  ${PROJECT_BINARY_DIR}
  ${PROJECT_SOURCE_DIR}/../corelib
)

grantlee_add_plugin(grantlee_defaultfilters
  defaultfilters

  FILTERS
    datetime
    integers
    lists
    logic
    misc
    strings
)

install(TARGETS grantlee_defaultfilters
         RUNTIME DESTINATION ${PLUGIN_INSTALL_DIR}
         LIBRARY DESTINATION ${PLUGIN_INSTALL_DIR}
         ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
         COMPONENT Devel
)

=== defaulttags/CMakeLists.txt ===
project(grantlee_defaulttags)

include(${Grantlee_USE_FILE})

include_directories(
  ${QT_INCLUDES}
  ${PROJECT_BINARY_DIR}
  ${PROJECT_SOURCE_DIR}/../corelib
)

grantlee_add_plugin ( grantlee_defaulttags
  defaulttags

  TAGS
    autoescape
    comment
    cycle
    debug
    filtertag
    firstof
    for
    if
    ifchanged
    ifequal
    load
    mediafinder
    now
    range
    regroup
    spaceless
    ssi
    templatetag
    widthratio
    with
)

install(TARGETS grantlee_defaulttags
        RUNTIME DESTINATION ${PLUGIN_INSTALL_DIR}
        LIBRARY DESTINATION ${PLUGIN_INSTALL_DIR}
        ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
        COMPONENT Devel
)

=== gui/CMakeLists.txt ===
project(grantlee_gui)

include_directories(
  ${QT_INCLUDES}
  ${PROJECT_BINARY_DIR}
)

include(${QT_USE_FILE})

set (grantlee_gui_SRCS
  bbcodebuilder.cpp
  markupdirector.cpp
  plaintextmarkupbuilder.cpp
  texthtmlbuilder.cpp
  mediawikimarkupbuilder.cpp
)

set(Grantlee_GUI_LIB_SOVERSION 0)

qt4_automoc(${grantlee_gui_SRCS})

add_library(grantlee_gui SHARED
  ${grantlee_gui_SRCS}
)

target_link_libraries(grantlee_gui
  ${QT_QTCORE_LIBRARY}
  ${QT_QTGUI_LIBRARY}
)

set_target_properties(grantlee_gui PROPERTIES
  VERSION    ${Grantlee_VERSION_MAJOR}.${Grantlee_VERSION_MINOR}.${Grantlee_VERSION_PATCH}
  SOVERSION  ${Grantlee_GUI_LIB_SOVERSION}
  DEFINE_SYMBOL GRANTLEE_GUI_LIB_MAKEDLL
)

install(TARGETS grantlee_gui
         RUNTIME DESTINATION ${BIN_INSTALL_DIR}
         LIBRARY DESTINATION ${LIB_INSTALL_DIR}
         ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
         COMPONENT Devel
)

install(FILES
  abstractmarkupbuilder.h
  bbcodebuilder.h
  markupdirector.h
  plaintextmarkupbuilder.h
  texthtmlbuilder.h
  mediawikimarkupbuilder.h
  grantlee_gui_export.h
  DESTINATION ${INCLUDE_INSTALL_DIR}/grantlee COMPONENT Devel
)

=== loadertags/CMakeLists.txt ===
project(grantlee_loadertags)

include(${Grantlee_USE_FILE})

include_directories(
  ${QT_INCLUDES}
  ${PROJECT_BINARY_DIR}
  ${PROJECT_SOURCE_DIR}/../corelib
)

grantlee_add_plugin(grantlee_loadertags
  loadertags

  TAGS
    block
    extends
    include
)

install(TARGETS grantlee_loadertags
         RUNTIME DESTINATION ${PLUGIN_INSTALL_DIR}
         LIBRARY DESTINATION ${PLUGIN_INSTALL_DIR}
         ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
         COMPONENT Devel
)

=== scriptabletags/CMakeLists.txt ===
project(grantlee_scriptabletags)

include_directories(
  ${QT_INCLUDES}
  ${PROJECT_BINARY_DIR}
  ${PROJECT_SOURCE_DIR}/../corelib
)

grantlee_add_plugin(grantlee_scriptabletags
  scriptablecontext
  scriptablefilterexpression
  scriptablenode
  scriptableparser
  scriptablesafestring
  scriptabletags
  scriptabletemplate
  scriptablevariable

  FILTERS
    scriptablefilter
)

target_link_libraries(grantlee_scriptabletags
  ${QT_QTSCRIPT_LIBRARY}
)

install(TARGETS grantlee_scriptabletags
         RUNTIME DESTINATION ${PLUGIN_INSTALL_DIR}
         LIBRARY DESTINATION ${PLUGIN_INSTALL_DIR}
         ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
         COMPONENT Devel
)

=== tests/pluginpointertest/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(sometest)

find_package(Qt4 REQUIRED)
include(${QT_USE_FILE})

set( EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR} )

include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_SOOURCE_DIR}/grantlee_core )

set(myplugin_headers myobject.h)
set(myplugin_sources myobject.cpp)

qt4_wrap_cpp(_plugin_moc_srcs ${myplugin_headers})

add_library(myplugin SHARED ${myplugin_sources} ${_plugin_moc_srcs})
set_target_properties(myplugin
  PROPERTIES PREFIX ""
)
target_link_libraries(myplugin
  ${QT_QTCORE_LIBRARIES}
)

add_executable(main_app main.cpp ${myplugin_sources} ${_plugin_moc_srcs})
target_link_libraries(main_app
  ${QT_QTCORE_LIBRARIES}
)

=== debian/changelog ===
grantlee (0.1.4-1) unstable; urgency=low

  * Initial release

 -- Bjoern Ricks <bjoern.ricks@intevation.de>  Thu, 29 Jul 2010 10:30:08 +0200 

=== debian/control ===
Source: grantlee
Section: libs
Priority: extra
Maintainer: Debian Krap Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Bjoern Ricks <bjoern.ricks@intevation.de>
Build-Depends: cdbs, debhelper (>= 5), libqt4-dev (>= 4.5), cmake
Standards-Version: 3.9.1
Homepage: http://www.grantlee.org/

Package: libgrantlee-gui0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Grantlee templating library for Qt - GUI
 Grantlee is a string template engine based on the Django template system
 and written in Qt.
 .
 This package contains the GUI part of Grantlee.

Package: libgrantlee-core0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Grantlee templating library for Qt - Core
 Grantlee is a string template engine based on the Django template system
 and written in Qt.
 .
 This package contains the core Grantlee library. It also includes the
 standard tag and filter plugins.

Package: libgrantlee-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libgrantlee-core0 (= ${binary:Version}),
 libgrantlee-gui0 (= ${binary:Version})
Description: Grantlee templating library development files
 Grantlee is a string template engine based on the Django template system
 and written in Qt.
 .
 This package contains the development files for building applications
 using grantlee.

## grantlee 0.1.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -31,9 +31,14 @@
   endif ()
 endif()
 
+add_definitions(-DQT_NO_CAST_TO_ASCII)
+add_definitions(-DQT_NO_CAST_FROM_ASCII)
+add_definitions(-DQT_STRICT_ITERATORS)
+add_definitions(-DQT_NO_URL_CAST_FROM_STRING)
+
 set(Grantlee_VERSION_MAJOR 0)
 set(Grantlee_VERSION_MINOR 1)
-set(Grantlee_VERSION_PATCH 4)
+set(Grantlee_VERSION_PATCH 7)
 set(Grantlee_MIN_PLUGIN_VERSION 1)
 
 set(Grantlee_MAJOR_MINOR_VERSION_STRING "${Grantlee_VERSION_MAJOR}.${Grantlee_VERSION_MINOR}" )
@@ -114,8 +119,12 @@
   message (STATUS "Doxygen and dot found. make docs target is available")
   # Add support for a docs target
 
-  set(TAGFILES "${CMAKE_SOURCE_DIR}/scripts/qttags.tag=http://qt.nokia.com/doc/${QT_VERSION_MAJOR}.${QT_VERSION_MINOR}")
-  set(DOCS_OUTPUT_DIRECTORY "@CMAKE_BINARY_DIR@/apidocs")
+  # Available from http://gcc.gnu.org/onlinedocs/libstdc++/latest-doxygen/libstdc++.tag
+  set(STLTAGFILE "${CMAKE_SOURCE_DIR}/scripts/libstdc++.tag=http://gcc.gnu.org/onlinedocs/libstdc++/latest-doxygen")
+  set(QTTAGFILE "${CMAKE_SOURCE_DIR}/scripts/qttags.tag=http://qt.nokia.com/doc/${QT_VERSION_MAJOR}.${QT_VERSION_MINOR}")
+
+  set(TAGFILES "${QTTAGFILE} ${STLTAGFILE}")
+  set(DOCS_OUTPUT_DIRECTORY "@CMAKE_BINARY_DIR@")
   configure_file(
     "${CMAKE_MODULE_PATH}/Doxyfile.in"
     "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile"
@@ -126,7 +135,13 @@
   # from http://api.kde.org/kdereview-api/kdereview.tar.gz for example.
   if(EXISTS ${CMAKE_SOURCE_DIR}/scripts/qttags.tag)
     set(DOCS_OUTPUT_DIRECTORY "@CMAKE_BINARY_DIR@/qtdocs")
-    set(TAGFILES "${CMAKE_SOURCE_DIR}/scripts/qttags.tag=qthelp://com.trolltech.qt/qdoc/")
+
+    # Available from http://steveire.com/libstdc++-longnames.tag
+    # Also recommended: http://www.steveire.com/libstdc++-v3.qch
+    set(STLTAGFILE "${CMAKE_SOURCE_DIR}/scripts/libstdc++-longnames.tag=qthelp://org.gnu.libstdcxx/libstdc++-v3/")
+    set(QTTAGFILE "${CMAKE_SOURCE_DIR}/scripts/qttags.tag=qthelp://com.trolltech.qt/qdoc/")
+
+    set(TAGFILES "${QTTAGFILE} ${STLTAGFILE}")
     set(GENERATE_QHP "yes")
 
     configure_file(

=== corelib/CMakeLists.txt ===
--- 
+++ 
@@ -12,18 +12,27 @@
 configure_file(grantlee_version.h.cmake ${PROJECT_BINARY_DIR}/grantlee_version.h)
 configure_file(grantlee_config_p.h.cmake  ${PROJECT_BINARY_DIR}/grantlee_config_p.h)
 
+# BIC: remove
+remove_definitions(-DQT_NO_CAST_TO_ASCII)
+remove_definitions(-DQT_NO_CAST_FROM_ASCII)
+
 set (grantlee_core_SRCS
+  cachingloaderdecorator.cpp
+  customtyperegistry.cpp
   context.cpp
   engine.cpp
   filterexpression.cpp
   lexer.cpp
+  metatype.cpp
   node.cpp
   nodebuiltins.cpp
   outputstream.cpp
   parser.cpp
+  rendercontext.cpp
   safestring.cpp
   template.cpp
   templateloader.cpp
+  typeaccessors.cpp
   util.cpp
   variable.cpp
 )
@@ -74,6 +83,8 @@
 )
 
 install(FILES
+  cachingloaderdecorator.h
+  containeraccessor.h
   context.h
   engine.h
   exception.h
@@ -81,13 +92,16 @@
   filterexpression.h
   grantlee_core_export.h
   ${PROJECT_BINARY_DIR}/grantlee_version.h
+  metatype.h
   node.h
   outputstream.h
   parser.h
+  rendercontext.h
   safestring.h
   taglibraryinterface.h
   template.h
   templateloader.h
+  typeaccessor.h
   token.h
   util.h
   variable.h

=== defaultfilters/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,6 @@
 project(grantlee_defaultfilters)
+
+include(${Grantlee_USE_FILE})
 
 include_directories(
   ${QT_INCLUDES}

=== loadertags/CMakeLists.txt ===
--- 
+++ 
@@ -8,8 +8,11 @@
   ${PROJECT_SOURCE_DIR}/../corelib
 )
 
+set_source_files_properties(blockcontext.h PROPERTIES SKIP_AUTOMOC TRUE)
+
 grantlee_add_plugin(grantlee_loadertags
   loadertags
+  blockcontext
 
   TAGS
     block

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -17,26 +17,42 @@
 set (_rcc_file "scriptedtags.qrc")
 qt4_add_resources(_scripted_rcc_src ${_rcc_file} OPTIONS -root "/plugins/grantlee/${Grantlee_MAJOR_MINOR_VERSION_STRING}" )
 
-macro(GRANTLEE_UNIT_TESTS)
+macro(GRANTLEE_CORE_UNIT_TESTS)
   foreach(_testname ${ARGN})
     set(_testSrcs ${_testname}.cpp)
     set(moc_output_file "${CMAKE_CURRENT_BINARY_DIR}/${_testname}.moc")
     qt4_generate_moc(${_testname}.cpp ${moc_output_file})
     add_executable(${_testname}_exec ${_testSrcs} ${moc_output_file} ${_scripted_rcc_src} ${CMAKE_SOURCE_DIR}/corelib/lexer.cpp)
     add_test(${_testname} ${_testname}_exec )
-    target_link_libraries(${_testname}_exec ${QT_QTTEST_LIBRARY} ${QT_QTGUI_LIBRARY} ${Grantlee_CORE_LIBRARIES} ${Grantlee_GUI_LIBRARY} )
+    target_link_libraries(${_testname}_exec ${QT_QTTEST_LIBRARY} ${QT_QTGUI_LIBRARY} ${Grantlee_CORE_LIBRARIES} )
   endforeach(_testname)
-endmacro(GRANTLEE_UNIT_TESTS)
+endmacro(GRANTLEE_CORE_UNIT_TESTS)
 
-grantlee_unit_tests(
+macro(GRANTLEE_GUI_UNIT_TESTS)
+  foreach(_testname ${ARGN})
+    set(_testSrcs ${_testname}.cpp)
+    set(moc_output_file "${CMAKE_CURRENT_BINARY_DIR}/${_testname}.moc")
+    qt4_generate_moc(${_testname}.cpp ${moc_output_file})
+    add_executable(${_testname}_exec ${_testSrcs} ${moc_output_file} )
+    add_test(${_testname} ${_testname}_exec )
+    target_link_libraries(${_testname}_exec ${QT_QTTEST_LIBRARY} ${QT_QTGUI_LIBRARY} ${Grantlee_GUI_LIBRARY} )
+  endforeach(_testname)
+endmacro(GRANTLEE_GUI_UNIT_TESTS)
+
+grantlee_gui_unit_tests(
+  htmlbuildertest
+  plainmarkupbuildertest
+)
+
+grantlee_core_unit_tests(
   testsafestring
   testbuiltins
   testloadertags
   testdefaulttags
   testscriptabletags
   testfilters
-  htmlbuildertest
-  plainmarkupbuildertest
+  testgenerictypes
+  testgenericcontainers
   benchmarks
 )

=== tests/templatedirs/CMakeLists.txt ===
project(template_dirs_test)

cmake_minimum_required(VERSION 2.6)

find_package(Qt4 REQUIRED)
find_package(Grantlee REQUIRED)

add_definitions(${QT_DEFINITIONS})
add_definitions(-DQT_GUI_LIB)
ADD_DEFINITIONS(-DQT_NO_KEYWORDS)

include_directories(
  ${QT_INCLUDES}
  ${QT_QTCORE_INCLUDE_DIR}
  ${Grantlee_INCLUDE_DIRS}
  ${PROJECT_BINARY_DIR}
)

configure_file(grantlee_paths.h.cmake ${PROJECT_BINARY_DIR}/grantlee_paths.h)

execute_process(COMMAND ${CMAKE_COMMAND} -E copy_directory ${PROJECT_SOURCE_DIR}/template_dir_1 ${PROJECT_BINARY_DIR}/template_dir_1)
execute_process(COMMAND ${CMAKE_COMMAND} -E copy_directory ${PROJECT_SOURCE_DIR}/template_dir_2 ${PROJECT_BINARY_DIR}/template_dir_2)

set(template_dirs_test_SRCS
  main.cpp
)

add_executable(template_dirs_test
  ${template_dirs_test_SRCS}
)

target_link_libraries(
  template_dirs_test
  ${QT_QTCORE_LIBRARIES}
  ${Grantlee_CORE_LIBRARIES}
)

=== debian/changelog ===
grantlee (0.1.7-0ubuntu4) oneiric; urgency=low

  * debian/copyright:
    - Correct license to LGPL-2.1+ instead of LGPL-2+
  * debian/libgrantlee-core0.symbols:
    - Update

 -- Michael Terry <mterry@ubuntu.com>  Fri, 08 Jul 2011 09:23:27 -0400

grantlee (0.1.7-0ubuntu3) natty; urgency=low

  * Revert previous upload and try again with the correct patch

 -- Scott Kitterman <scott@kitterman.com>  Tue, 07 Dec 2010 09:19:01 -0500

grantlee (0.1.7-0ubuntu2) natty; urgency=low

  * Backport upstream commits 128272d4f65d7f02372cb606c148817c2f15a78d and
    5a71ed118f6fae67a4a26ab867ab7575e5a3e34c to moderate test requirements so
    it will build on armel
  * Include missing grantlee_i18ntags.so and grantlee_mutabletags.so in
    libgrantlee-core0

 -- Scott Kitterman <scott@kitterman.com>  Tue, 07 Dec 2010 08:09:15 -0500

grantlee (0.1.7-0ubuntu1) natty; urgency=low

  * New upstream release

 -- Jonathan Riddell <jriddell@ubuntu.com>  Mon, 22 Nov 2010 13:18:59 +0000

grantlee (0.1.4-1ubuntu1) maverick; urgency=low

  * Make libgrantlee-core0  and libgrantlee-gui0 conflict/replace libgrantlee0
    (LP: #614859) 

 -- Philip Muskovac <yofel@gmx.net>  Sun, 08 Aug 2010 01:39:01 +0200

=== debian/rules ===
#!/usr/bin/make -f

DEB_DH_INSTALL_SOURCEDIR := debian/tmp

include /usr/share/cdbs/1/class/cmake.mk
include /usr/share/cdbs/1/rules/debhelper.mk

DEB_DH_MAKESHLIBS_ARGS_ALL = -V -u-c0

## grantlee 0.2.0

=== debian/changelog ===
grantlee (0.2.0-0ubuntu1) precise; urgency=low

  * New upstream release
  * Merge with Debian, remaining changes:
   - conflict/replace old libgrantlee0
  * Remove missing symbols from .symbols files, upstream says they are no longer
    all virtual but they are inline

 -- Jonathan Riddell <jriddell@ubuntu.com>  Thu, 08 Dec 2011 22:46:54 +0000

grantlee (0.1.7-1) unstable; urgency=low

  * New upstream release 
  * Set compat level to 7
  * Include cdbs util.mk in rules to check missing files
  * Enable DEB_BUILD_PARALLEL

 -- Bjoern Ricks <bjoern.ricks@intevation.de>  Fri, 10 Dec 2010 11:22:37 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: grantlee
 Section: libs
 Priority: extra
-Maintainer: Debian Krap Maintainers <debian-qt-kde@lists.debian.org>
+Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Krap Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Bjoern Ricks <bjoern.ricks@intevation.de>
 Build-Depends: cdbs, debhelper (>= 5), libqt4-dev (>= 4.5), cmake
 Standards-Version: 3.9.1
@@ -10,6 +11,8 @@
 Package: libgrantlee-gui0
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Conflicts: libgrantlee0 (<= 0.1.2-0ubuntu1)
+Replaces: libgrantlee0 (<= 0.1.2-0ubuntu1)
 Description: Grantlee templating library for Qt - GUI
  Grantlee is a string template engine based on the Django template system
  and written in Qt.
@@ -19,6 +22,8 @@
 Package: libgrantlee-core0
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Conflicts: libgrantlee0 (<= 0.1.2-0ubuntu1)
+Replaces: libgrantlee0 (<= 0.1.2-0ubuntu1)
 Description: Grantlee templating library for Qt - Core
  Grantlee is a string template engine based on the Django template system
  and written in Qt.

## grantlee 0.3.0

=== debian/changelog ===
grantlee (0.3.0-5) unstable; urgency=low

  * Slightly modify libgrantlee-dev.install so it is not affected by the actual
    build type used.
  * Add myself to Uploaders.
  * Add grantlee-dbg with debug symbols.

 -- Pino Toscano <pino@debian.org>  Sun, 26 May 2013 08:34:08 +0200

grantlee (0.3.0-4) unstable; urgency=low

  * Team upload.
  * Update symbols files.
  * Fix Grantlee on architectures where qreal is not double but float; patches
    variantIsTrue-float-fix.diff and testinternationalization-qreal.diff.
  * Turn dh_install's --list-missing into --fail-missing.
  * Use wildcards in .install files.
  * Ignore test suite failures on ia64 and sparc64. Apparently QtScript seems
    buggy on these archs, leading to failures in few Grantlee tests; since also
    older Grantlee versions fail the same way, ignore such failures for now.
  * Add Build-Depends-Package in symbols files.

 -- Pino Toscano <pino@debian.org>  Wed, 15 May 2013 14:14:28 +0200

grantlee (0.3.0-3) unstable; urgency=low

  * Team upload.
  * Update symbols files.
  * Update Vcs-* headers.
  * Add the pkg-kde-tools build dependency and make use of the
    pkgkde_symbolshelper dh addon for subst-using symbols.
  * Enable the test suite:
    - padd -DENABLE_TESTS=ON to cmake
    - run dh_auto_test under xvfb-run, as some tests need X
    - add the xvfb and xauth build dependencies
  * Remove extra ${shlibs:Depends} from libgrantlee-dev.
  * Make libgrantlee-dev depend on libqt4-dev.

 -- Pino Toscano <pino@debian.org>  Tue, 14 May 2013 10:45:09 +0200

grantlee (0.3.0-2) unstable; urgency=low

  * Add myself to uploaders
  * Add a watch file
  * Bump debhelper build-dep and compat to 9
  * Bump Standards-Version to 3.9.4
  * Add Vcs-Git and Vcs-Browser fields
  * Migrate cdbs to dh
  * Update symbols files

 -- Maximiliano Curia <maxy@debian.org>  Sun, 12 May 2013 13:24:24 +0200

grantlee (0.3.0-1) experimental; urgency=low

  * New upstream release
  * Add myself to uploaders
  * Update symbols files

 -- Sune Vuorela <sune@debian.org>  Mon, 25 Mar 2013 15:46:10 +0100

grantlee (0.2.0-1) unstable; urgency=low

  * New upstream reelase
  * Add grantlee_i18ntags.so plugin to libgrantlee-core0

 -- Bjoern Ricks <bjoern.ricks@intevation.de>  Wed, 15 Feb 2012 13:26:47 +0100

=== debian/control ===
Source: grantlee
Section: libs
Priority: extra
Maintainer: Debian Krap Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Bjoern Ricks <bjoern.ricks@intevation.de>,
           Sune Vuorela <sune@debian.org>,
           Maximiliano Curia <maxy@debian.org>,
           Pino Toscano <pino@debian.org>
Build-Depends: debhelper (>= 9), libqt4-dev (>= 4.5), cmake, pkg-kde-tools,
 xvfb, xauth
Standards-Version: 3.9.4
Homepage: http://www.grantlee.org/
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-kde/krap/grantlee.git;a=summary
Vcs-Git: git://anonscm.debian.org/pkg-kde/krap/grantlee.git

Package: libgrantlee-gui0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Grantlee templating library for Qt - GUI
 Grantlee is a string template engine based on the Django template system
 and written in Qt.
 .
 This package contains the GUI part of Grantlee.

Package: libgrantlee-core0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Grantlee templating library for Qt - Core
 Grantlee is a string template engine based on the Django template system
 and written in Qt.
 .
 This package contains the core Grantlee library. It also includes the
 standard tag and filter plugins.

Package: libgrantlee-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libgrantlee-core0 (= ${binary:Version}),
 libgrantlee-gui0 (= ${binary:Version}), libqt4-dev
Description: Grantlee templating library development files
 Grantlee is a string template engine based on the Django template system
 and written in Qt.
 .
 This package contains the development files for building applications
 using grantlee.

Package: grantlee-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${misc:Depends},
 libgrantlee-core0 (= ${binary:Version}) | libgrantlee-gui0 (= ${binary:Version})
Suggests: libqt4-dbg
Description: Grantlee templating library (debugging symbols)
 Grantlee is a string template engine based on the Django template system
 and written in Qt.
 .
 This package contains the debugging symbols used to investigate issues in
 Grantlee.
